<!DOCTYPE html>
<html lang="en">

<head>
    <title>Bootstrap Example</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>

    <div class="container">
        <h2 style="text-align: center;">Danh sách người dùng</h2>

        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    $(document).ready(function () {
        
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gNameCol = ["userId", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
      const gUSER_ID = 0;
      const gFIRST_NAME = 1;
      const gLAST_NAME = 2;
      const gCOUNTRY = 3;
      const gSUBJECT = 4;
      const gCUSTOMER_TYPE = 5;
      const gREGISTER_STATUS = 6;
      const gACTION = 7;
      $("#user-table").DataTable({
          columns: [
            { data: gNameCol[gUSER_ID] },
            { data: gNameCol[gFIRST_NAME] },
            { data: gNameCol[gLAST_NAME] },
            { data: gNameCol[gCOUNTRY] },
            { data: gNameCol[gSUBJECT] },
            { data: gNameCol[gCUSTOMER_TYPE] },
            { data: gNameCol[gREGISTER_STATUS] },
            { data: gNameCol[gACTION] },

          ],
          columnDefs: [
            {
              targets: gACTION,
              defaultContent: '<button class="btn btn-info btn-detail">Chi tiết</button>'
            }
          ]
        });
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();
        $(document).on("click", "#user-table .btn-detail", function(){
            onBtnDetailClick(this);
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading(){
            $.ajax({
                url:'http://203.171.20.210:8080/devcamp-register-java-api/users',
                type:'GET',
                dataType:'json',
                
                success: function(paramObject){
                    //console.log(paramObject);
                    loadDataToTable(paramObject);
                },
                error: function(ajaxContext){
                    alert(ajaxContext.responseText);
                } 
            });
        }
        function loadDataToTable(paramObject){
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramObject);
        vTable.draw();
        }
        function onBtnDetailClick(paramElement){
            var vRowClick = $(paramElement).parents("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRowClick).data();

        console.log("User Id: " + vDataRow.id);
        console.log("User First name: " + vDataRow.firstname);
        console.log("User Last name: " + vDataRow.lastname);
        console.log("User Country: " + vDataRow.country);
        console.log("User Subject: " + vDataRow.subject);
        console.log("User Customer Type: " + vDataRow.customerType);
        console.log("User Register Status: " + vDataRow.registerStatus);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/


    });
</script>

</html>